<?php
/**
 * Created by JetBrains PhpStorm.
 * User: erikasouza
 * Date: 14/11/12
 * Time: 13:40
 * To change this template use File | Settings | File Templates.
 */
namespace Estoque\Logic\FechamentoDia;

use Estoque\Entities\Itlanctoest;

use Setforms2\Runtime\Helper\Procedure\Param;

class ExportaIN86 extends \Estoque\Logic\FechamentoDia\ExportAbstract
{

    private $nrorg;
    private $cdFilial;
    private $dtProc;
    private $dtProcProx;
    private $nrDia;
    private $cdRelatorio;
    private $cdMovi;


    public function __construct($param){
        $this->nrorg = $param['NRORG'];
        $this->cdFilial = $param['CDFILIAL'];
        $this->dtProc = $param['DTPROC'];
        $this->dtProcProx = $param['DTPROCPROX'];
        $this->nrDia = $param['NRDIAARQEXP'];
        $this->cdRelatorio = $param['CDRELATEXP'];
        $this->cdMovi = $param['CDMOVI'];
    }


    public function executaProcedure(){
        if ($this->nrDia === 'DI') {
            $dtInicio = $this->dtProc;

            $data = new \TkDateTime($this->dtProcProx);
            $dtFinal = $data->subDay(1)->toString();
        } else {
            $util = new Util();
            /** @var $datas Util */
            $datas = $util->primeiroUltimoDiaMes($this->dtProc);
            $dtInicio = $datas->primeiroDiaMes;
            $dtFinal = $datas->ultimoDiaMes;
        }

        $data = new \TkDateTime($this->dtProcProx);
        $dtProxProc = $data->subDay(1)->toString();

        $produto = new \Geral\Util\PictureProduto($this->nrorg);
        $nivel = $produto->getNumeroDeNiveis();

        $params = array( new Param("P_CDFILIAL",
            Param::PARAM_INPUT,
            $this->cdFilial,
            Param::PARAM_TYPE_STR
            ),
            new Param("P_DTINIRET",
                Param::PARAM_INPUT,
                $dtInicio,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_DTFINRET",
                Param::PARAM_INPUT,
                $dtFinal,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_DATAPROC",
                Param::PARAM_INPUT,
                $this->dtProc,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_DATAPOS",
                Param::PARAM_INPUT,
                $dtProxProc,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_TOTNIVEL",
                Param::PARAM_INPUT,
                $nivel,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_NUMEMOVI",
                Param::PARAM_INPUT,
                $this->cdMovi,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_ARQUIVO",
                Param::PARAM_INPUT,
                strtoupper($this->cdRelatorio),
                Param::PARAM_TYPE_STR
            ),
            new Param("P_EXPCADMAT",
                Param::PARAM_INPUT,
                'N',
                Param::PARAM_TYPE_STR
            ),
            new Param("P_EXPMANUAL",
                Param::PARAM_INPUT,
                'N',
                Param::PARAM_TYPE_STR
            ),
        );

        $this->chamaProcedure('EXPORTA_IN86', $params);
    }


    public function executaRelatorio()
    {
        // TODO: Implement executaRelatorio() method.
    }


}
